/*	
 *	d12sys.c
 *
 *	PDIUSBD12 VXevO
 *	Copyright (c) 1997 Philips Semiconductors
 *	Copyright (c) 2002 Naoyuki Sawa
 *
 *	* Mon Aug 16 12:30:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include <piece.h>
#include <s1c33cpu.h>
#include "c33209.h"
#include "d12ci.h"
#include "d12sys.h"

/****************************************************************************
 *	֐錾
 ****************************************************************************/

static void usb_isr();
static void fn_usb_isr();
static void bus_reset();
static void ep0_rxdone(int st);
static void ep0_txdone(int st);
static void ep1_rxdone(int st);
static void ep1_txdone(int st);
static void ep2_rxdone(int st);
static void ep2_txdone(int st);
static void device_request(const DEVICE_REQUEST* req, const unsigned char* dat, int len);

/****************************************************************************
 *	[Jϐ
 ****************************************************************************/

static PCEKSENT old_usb_isr;		/* ̊荞݃nh(NULL:tbNĂȂ) */
static USBINFO usb_info;		/* USBtbN */

/* Rg[] */
#define STATE_IDLE		 0	/* Rg[f[^MȂ                */
#define STATE_RXING		 1	/* Rg[f[^M                    */
#define STATE_TXING		 2	/* Rg[f[^M                    */
#define DATA_BUFFER_SIZE	16	/* MRg[f[^TCY(ő)E  */
typedef struct _CONTROL_XFER {
	int state;			/* M                                  */
	DEVICE_REQUEST device_request;	/* foCXNGXgMobt@              */
	int data_length;		/* MRg[f[^TCY(S)        */
	int data_count;			/* Mς݃Rg[f[^TCY(is)    */
	unsigned char data_buffer[DATA_BUFFER_SIZE]; /* MRg[f[^obt@ */
	const unsigned char* data_ptr;	/* MRg[f[^|C^(擪)        */
} CONTROL_XFER;
static CONTROL_XFER control_xfer;

/****************************************************************************
 *	[J֐
 ****************************************************************************/

static void
usb_isr()
{
	/* * 荞ݏ[`̖{̂ĂяołB
	 *   INT_END2retiŒږ߂̂ŁA(orÖق)[JϐĂ͂܂B
	 *   炱̊֐ł͂Ȃׂs킸ɁAۂ̏fn_usb_isr()ɔC܂B
	 *
	 * * 荞ݗvtO֘ȀԑJڂ͎̂悤ɂȂ܂F
	 *
	 *								USBC̊荞	USBC		ITC̊荞
	 *								vtO	INT_N[q	vtO
	 *	0. 荞ݔ						P		P		P
	 *	1. ITC̊荞ݗvtONA			P		P		O
	 *	2. 荞݋						P		P		O
	 *	   CPŮ荞݋xUSBC荞݃x
	 *	   ȂĂ̂ŁAUSBC荞݂̓ubNB
	 *	   ʂ̊荞(TEhȂ)͎󂯕tB
	 *	3. USBC̊荞ݗvtONA			O		O		O
	 *	4. retiɂACPŮ荞݃x			O		O		O
	 *	   USBC荞݂󂯕t悤ɂȂB
	 *
	 *   ̎菇ƁAꌩÂ悤ȐSzĂ܂܂B
	 *
	 *	2.̎_ INT_N=1 Ȃ̂ōĂ ITC̊荞ݗvtO=1 ɂȂA(USBC荞݂̓xgK)
	 *	4.̎_܂ŃyfBOꂽAreti̒ɂ܂荞݂̂ł͂ȂH
	 *	ITC̊荞ݗvtONAOɁAUSBC̊荞ݗvtONAȂ΂Ȃ̂ł͂ȂH
	 *
	 *   A̐Sz͕svłB
	 *   ITC̊荞ݗvtOZbĝ́AwۂɊ荞݂_xłB
	 *   is1c33209_221_222j.pdf II-5 ITC(荞݃Rg[) B-II-5-2 u}XN\Ȋ荞݂̔v QƁj
	 *   DMAgKȂǂƂ͈قȂA荞݃ubNԂŊ荞ݗvtOZbgEyfBO邱Ƃ͂܂B
	 *   2.̎_ŁAUSBC荞݂CPŮ荞݃xɂăubNĂ̂ŁA荞ݗvtO̓Zbg܂B
	 */
	INT_BEGIN2;
	bINT_FK01_FP03_FP1 = 0;	/* (1.) */
	//̊荞ݏƂ̔rƂȂꍇ́Ad荞݂ȂSłB
	//ENABLE;		/* (2.) */
	fn_usb_isr();		/* (3.) */
	INT_END2;		/* (4.) */
}

static void
fn_usb_isr()
{
	int st;

	/* 荞ݗv擾ENA܂B */
	st = D12_ReadInterruptRegister();

	/* oXZbgȂ瑼̗v͖܂B
	 * * oXZbgCxǵAUSBP[uڑuԂɓAŔ悤łB
	 *   USBP[u𔲂ɂ͔܂Bij
	 */
	if(st & D12_INT_BUSRESET) {
		bus_reset();
	/* oXZbgȊO̗v܂B */
	} else {
		if(st & D12_INT_SUSPENDCHANGE) { /* ܂ */ }
		if(st & D12_INT_EOT) { /* DMAM͌Ă܂ */ }
		/* K{ID12_ReadLastTransactionStatus()ŁA]tONA܂B */
		if(st & D12_INT_ENDP0OUT) ep0_rxdone(D12_ReadLastTransactionStatus(0));
		if(st & D12_INT_ENDP0IN ) ep0_txdone(D12_ReadLastTransactionStatus(1));
		if(st & D12_INT_ENDP1OUT) ep1_rxdone(D12_ReadLastTransactionStatus(2));
		if(st & D12_INT_ENDP1IN ) ep1_txdone(D12_ReadLastTransactionStatus(3));
		if(st & D12_INT_ENDP2OUT) ep2_rxdone(D12_ReadLastTransactionStatus(4));
		if(st & D12_INT_ENDP2IN ) ep2_txdone(D12_ReadLastTransactionStatus(5));
	}
}

static void
bus_reset()
{
	if(usb_info.bus_reset != NULL) usb_info.bus_reset();
}

static void
ep0_rxdone(int st)
{
	int retval;

	/* SETUPpPbgM... */
	if(st & D12_SETUPPACKET) {
		/* ܂AChԂɂĂ܂B
		 * Rg[f[^MłASETUPpPbgMƑM̓LZ܂B
		 */
		control_xfer.state = STATE_IDLE;

		/* foCXNGXgǂݍ݂܂B */
		retval = D12_ReadEndpoint(0, &control_xfer.device_request, sizeof(DEVICE_REQUEST));
		if(retval != sizeof(DEVICE_REQUEST)) {
			usb_ep0_stall();
			return;
		}

		/* SETUPpPbgMɂEP0~Ă̂ŁAA܂B */
		D12_AcknowledgeSetup(0);
		D12_AcknowledgeSetup(1);

		/* Rg[f[^̑MTCY܂B */
		control_xfer.data_length = control_xfer.device_request.wLength;
		control_xfer.data_count  = 0;

		/* Rg[f[^̑Mɂ... */
		if(control_xfer.device_request.bmRequestType & 0x80) { /* Data transfer direction */
			/* Device-to-host (GET) */
			device_request(&control_xfer.device_request, NULL, 0);
		} else {
			/* Host-to-device (SET) */
			if(control_xfer.data_length == 0) {
				/* Rg[f[^͂Ȃ̂ŁAɃfoCXNGXg܂B */
				device_request(&control_xfer.device_request, NULL, 0);
			} else {
				/* Rg[f[^MƂŁAfoCXNGXg܂B */
				if(control_xfer.data_length > DATA_BUFFER_SIZE) {
					usb_ep0_stall();
					return;
				}
				control_xfer.state = STATE_RXING;
			}
		}

	/* Rg[f[^MȂ... */
	} else if(control_xfer.state == STATE_RXING) {
		/* Rg[f[^̎MAfoCXNGXg܂B
		 * zXgfoCX̃Rg[f[^́AKfoCXNGXgŎw肳ꂽTCY҂ŏI܂B
		 * oN]̂悤ɁAyC[hTCỸpPbg̃pPbgɂďI[ꂽ͂܂B
		 * [usb_20.pdf p.30]
		 * The Data stage of a control transfer from the host to an endpoint is complete when all of the data has been
		 * transferred. If the endpoint receives a larger-than-expected data payload from the host, it halts the pipe.
		 */
		retval = D12_ReadEndpoint(0, control_xfer.data_buffer + control_xfer.data_count,
					     control_xfer.data_length - control_xfer.data_count);
		control_xfer.data_count += retval;
		if(control_xfer.data_count == control_xfer.data_length) {
			control_xfer.state = STATE_IDLE;
			device_request(&control_xfer.device_request, control_xfer.data_buffer, control_xfer.data_length);
		}

	} else {
		/* ԂGETNGXg̃Xe[^XXe[WŁAzXg̋pPbgMʒmłB
		 * SETUPpPbgMɂAMobt@͎IɃNÂŁAIɋɂĂKv͂܂B
		 * ]āAł͉܂B
		 */
	}
}

static void
ep0_txdone(int st)
{
	int len;

	/* Rg[f[^MȂ... */
	if(control_xfer.state == STATE_TXING) {
		/* Rg[f[^yC[hTCYɕđM܂B
		 * * foCXzXg̃Rg[f[^́AfoCXNGXgŎw肳ꂽTCY҂肩A
		 *   ܂̓oN]ƓlɁAyC[hTCỸpPbg̃pPbgɂďI[܂B
		 * * ݂̎ł́ufoCXNGXgŎw肳ꂽTCY҂vƂlĂȂ̂ŁA
		 *   w肳ꂽTCYyC[hTCY̐{ꍇɁA]vȋpPbg𑗂Ă܂܂B
		 *   zXgŗ]vȋpPbg𖳎Ă邱Ƃ҂āAƂ肠̂܂܂ɂĂ܂B
		 * [usb_20.pdf p.30]
		 * The Data stage of a control transfer from an endpoint to the host is complete when the endpoint does one of
		 * the following:
		 *  Has transferred exactly the amount of data specified during the Setup stage
		 *  Transfers a packet with a payload size less than wMaxPacketSize or transfers a zero-length packet
		 * When a Data stage is complete, the Host Controller advances to the Status stage instead of continuing on
		 * with another data transaction. If the Host Controller does not advance to the Status stage when the Data
		 * stage is complete, the endpoint halts the pipe as was outlined in Section 5.3.2. If a larger-than-expected data
		 * payload is received from the endpoint, the IRP for the control transfer will be aborted/retired.
		 */
		len = control_xfer.data_length - control_xfer.data_count;
		if(len > EP0_PACKET_SIZE) len = EP0_PACKET_SIZE;
		D12_WriteEndpoint(1, control_xfer.data_ptr + control_xfer.data_count, len);
		control_xfer.data_count += len;
		if(len < EP0_PACKET_SIZE) control_xfer.state = STATE_IDLE;

	} else {
		/* ԂSETNGXg̃Xe[^XXe[WŁAzXgւ̋pPbgMʒmłB
		 * ł͉܂B
		 */
	}
}

static void
ep1_rxdone(int st)
{
	if(usb_info.ep1_rxdone != NULL) usb_info.ep1_rxdone(st);
}

static void
ep1_txdone(int st)
{
	if(usb_info.ep1_txdone != NULL) usb_info.ep1_txdone(st);
}

static void
ep2_rxdone(int st)
{
	if(usb_info.ep2_rxdone != NULL) usb_info.ep2_rxdone(st);
}

static void
ep2_txdone(int st)
{
	if(usb_info.ep2_txdone != NULL) usb_info.ep2_txdone(st);
}

static void
device_request(const DEVICE_REQUEST* req, const unsigned char* dat, int len)
{
	switch(req->bmRequestType & 0x60) { /* Type */
	case 0x00: /* Standard request */
		if(usb_info.standard_request != NULL) {
			usb_info.standard_request(req, dat, len);
			return;
		}
		break;
	case 0x20: /* Class request */
		if(usb_info.class_request != NULL) {
			usb_info.class_request(req, dat, len);
			return;
		}
		break;
	case 0x40: /* Vendor request */
		if(usb_info.vendor_request != NULL) {
			usb_info.vendor_request(req, dat, len);
			return;
		}
		break;
	}
	usb_ep0_stall(); /* Ή̃NGXgȂAXg[܂ */
}

/****************************************************************************
 *	O[o֐
 ****************************************************************************/

#define USBC_TRAP_NO	17	/* USBC荞݃xN^ԍ    */
#define RECONNECT_WAIT	200	/* USBؒf`ڑEFCg[ms] */

void
usb_hook(const USBINFO* ui)
{
	int T0;

	/* ܂mɃtbN܂B */
	usb_unhook();

	/* J[lUSB䌠B */
	pceUSBDisconnect();

	/* zXgؒfoł悤ɁAEFCgB */
	T0 = pceTimerGetCount();
	while(pceTimerGetCount() - T0 < RECONNECT_WAIT) { }

	/* USBtbNi[܂B */
	usb_info = *ui;

	/* USBC荞݂tbNB */
	old_usb_isr = pceVectorSetTrap(USBC_TRAP_NO, usb_isr);

	/* USBڑB */
	D12_SetMode(usb_info.mode | D12_SOFTCONNECT, D12_SETTOONE);
}

void
usb_unhook()
{
	int T0;

	/* tbNĂȂΉ܂B */
	if(old_usb_isr == NULL) return;

	/* USBؒfB */
	D12_SetMode(0, D12_SETTOONE);

	/* zXgؒfoł悤ɁAEFCgB */
	T0 = pceTimerGetCount();
	while(pceTimerGetCount() - T0 < RECONNECT_WAIT) { }

	/* USBC荞݂ɖ߂B */
	pceVectorSetTrap(USBC_TRAP_NO, old_usb_isr);
	old_usb_isr = NULL; /* tbNƂ}[N */

	/* J[lUSB䌠𕜋AB */
	pceUSBReconnect();
}

void
usb_ep0_stall()
{
	D12_SetEndpointStatus(0, 1); /* EP0-OUT(zXgfoCX)~ */
	D12_SetEndpointStatus(1, 1); /* EP0-IN (foCXzXg)~ */
}

void
usb_ep0_tx(const char* ptr, int len)
{
	/* dv
	 * * GETNGXgւ̉ŁAwLength傫ȃTCỸf[^𑗂ԂƂƁA
	 *   zXgƂ̏ԑJڂ̓@ȂȂAusȃfoCXvɂȂĂ܂܂I
	 * * ႦGET_DESCRIPTOR(CONFIGURATION)̏ꍇA܂wLength=9ŗv݂łB(Win2KŊmF)
	 *   ӂARtBM[VfBXNv^9oCgł͎܂Ȃ̂ŁA
	 *   RtBM[VfBXNv^Ŝ̐擪9oCgԂ悤ɂ܂B
	 *   ƁAzXgƑ傫wLengthw肵āAēxGET_DESCRIPTORv悤łB
	 * * wLength=9Ȃ̂9oCgȏ̃f[^𑗂ԂƂƁAOq̂Ƃn}܂B
	 *   vӂłII
	 * * wLength邩ƂāAXg[Ă܂Ă͂܂I
	 *   wLength́̕AԂKv܂B
	 *   Xg[Ă܂ƁA͂usȃfoCXvɂȂĂ܂܂B
	 * * wLengthQƂăf[^TCY؂l߂Ƃ́A{d12usr.c̃foCXNGXgnhōsׂłB
	 *   AɕKvȍƂȂ̂ŁAł܂Ƃ߂Đ؂l߂Ă܂Ƃɂ܂B
	 *   d12usr.c̃foCXNGXgnh́AMf[^؂l߂ꂽƂ֒m܂B
	 * [usb_20.pdf p.253]
	 * The wLength field specifies the number of bytes to return. If the descriptor is longer than the wLength field,
	 * only the initial bytes of the descriptor are returned. If the descriptor is shorter than the wLength field, the
	 * device indicates the end of the control transfer by sending a short packet when further data is requested. A
	 * short packet is defined as a packet shorter than the maximum payload size or a zero length data packet (refer
	 * to Chapter 5).
	 */
	if(control_xfer.device_request.bmRequestType & 0x80) { /* Data transfer direction = Device-to-host (GET) */
		if(len > control_xfer.device_request.wLength) len = control_xfer.device_request.wLength;
	}

	/* * GETNGXgɑ΂Rg[f[^Xe[W(M)ŁAf[^𑗐M邽߂ɗpꍇ́A
	 *    data_count=0 ɂȂĂ̂ŁAdata_count<-0 ̓_~[ƂȂ܂B
	 * * SETNGXgɑ΂Xe[^XXe[W(M)ŁApPbgԐM邽߂ɗpꍇ́A
	 *   Rg[f[^M̂߂ data_count gꂽȂ̂ŁAdata_count<-0 K{łB
	 * * Ƃ킯ŁAȒP̂߂ɁAł data_count<-0 sƂɂ܂B
	 */
	control_xfer.data_length = len;
	control_xfer.data_count = 0;
	control_xfer.data_ptr = ptr;

	/* ̃f[^]B(㑱̃f[^]Ƃ邱ƓȂ̂ŁA]nh𗘗p) */
	control_xfer.state = STATE_TXING; /* KvI */
	ep0_txdone(D12_INT_ENDP0IN);
	/* œ]Aep0_txdone() state=STATE_IDLE ɖ߂Ă܂B */
}

